MIXTURES - Mixtures


Harry Potter has n mixtures in front of him, arranged in a row. Each mixture has one of 100 different colors (colors have numbers from 0 to 99).

He wants to mix all these mixtures together. At each step, he is going to take two mixtures that stand next to each other and mix them together, and put the resulting mixture in their place.

When mixing two mixtures of colors a and b, the resulting mixture will have the color (a+b) mod 100.

Also, there will be some smoke in the process. The amount of smoke generated when mixing two mixtures of colors a and b is a*b.

Find out what is the minimum amount of smoke that Harry can get when mixing all the mixtures together.

Input

There will be a number of test cases in the input.

The first line of each test case will contain n, the number of mixtures, 1 <= n <= 100.

The second line will contain n integers between 0 and 99 - the initial colors of the mixtures.

Output

For each test case, output the minimum amount of smoke.

Example

Input:
2
18 19
3
40 60 20

Output:
342
2400

In the second test case, there are two possibilities:

  • first mix 40 and 60 (smoke: 2400), getting 0, then mix 0 and 20 (smoke: 0); total amount of smoke is 2400
  • first mix 60 and 20 (smoke: 1200), getting 80, then mix 40 and 80 (smoke: 3200); total amount of smoke is 4400

The first scenario is a much better way to proceed.


hide comments
popat: 2017-02-09 14:36:35

what should be answer for
100
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100


i got 120675 is it correct

roopansh: 2017-02-01 14:25:57

don't use "ios_base::sync_with_stdio(false);cin.tie(0);"

it would give WA

flyingduchman_: 2016-12-24 14:26:04

It is a modified matrix chain multiplication(MCM) problem.
First learn MCM algorithm from a video(like: youtube, Tusher Roy's…) and practice it in pen-paper(perfectly). Then try to implement it by yourself(you must consider matrix-length in your loops. Then see the dp(dynamic programming) solution of a reference like:geeks for geeks and refine it if you did any mistake.
Now try to discover the formula of this problem. Stop reading further ...(do all these above). This problem need length L upto <=n;
formula, I discovered: M[i,j] =Minimum{ M[i,k] + M[k+1,j]+ temp };1<=i<=k<j

where , if(i == k) then temp = (sum{k+1,to, j} = sum(a[k+1-1]+..+a[j-1]))%100 * a[i-1]. as index starts at zero.
else if(k+1 ==j) then temp = sum(a[i-1]+..+a[k-1]) %100 * a[j-1].

else temp = sum(a[k+1-1]+..+a[j-1])%100 * (sum(a[i-1]+..+a[k-1])%100).

Note that: a[] is input and M[n+1][n+1] is a dp bottom-up table. index starts from 0 in a[] but in M[][] it starts from 1 because of the MCM formula(a[i-1] is used).

Last edit: 2016-12-24 15:53:41
kira28: 2016-12-19 18:18:15

Nice DP...
A must do for DP beginners like me:)

ov3rk1ll: 2016-11-27 07:54:36

use scanf/printf got tle with cin/cout

shubham2305: 2016-11-15 16:47:43

compliation error C++ 4.3.2 but ac c++14

adichd123: 2016-07-22 07:08:48

Nice question for learning MCM!!

sonali9696: 2016-07-17 23:11:29

while(scanf("%d",&n)) gives TLE as EOF returns EOF whose value is -1. Thus write while(scanf("%d",&n) > 0) OR while(scanf("%d",&n) == 1) OR while(scanf("%d",&n) != -1)

Last edit: 2016-07-17 23:13:32
Aman Agarwal: 2016-06-25 14:28:38

matrix chain multiplication ✌

Last edit: 2016-06-25 14:29:12
TP: 2016-06-23 10:44:04

Must check for n=1 , it costs me a WA. Simple Dp :)


Added by:Tomek Czajka
Date:2005-05-03
Time limit:3s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: NODEJS PERL6 VB.NET
Resource:Purdue Programming Contest Training